; vMon 1.0
;
; Nickname text monitoring script, written for maverick] by
; Variant - variant@variantrealities.com

; This is affectionately called vMon ... :) Just something simple 
; so that aliases can be named accordingly.


; Usage:
;
; Put this file, and the other 3 (monitor.txt, nicks.txt, sendto.txt) in
; the directory of your choice (usually c:\mirc\vmon\), then load up
; this file via //load -rs c:\mirc\vmon\vmon.mrc (or wherever you put
; this file). Monitoring will start automatically...
;
; To add/remove nicknames that should be monitored, edit Nicks.txt
; and put the nicknames on separate lines.
;
; Use this same procedure for adding text to be monitored (monitor.txt), and also
; for channels for the text to be forwarded to (sendto.txt). Text will be forwarded
; except for the last two words.

; Example:
;
; <somenick> somegroup-NEW RELEASE here.is.the.release.name by courier
;
; If somenick is in your nicks.txt, and NEW RELEASE is in your monitor.txt file,
; then "somegroup-NEW RELEASE here.is.the.release.name" will be forwarded
; to all the channels you have listed in sendto.txt --- the "by courier" part will
; be removed.


; Lastly - if you edit nicks.txt, monitor.txt, or sendto.txt, then you need to type
; /vMon.Load at the command line in order to load up the new changes. This is
; due to vMon using hash tables to make sure things are fast.


; Planned additions:
; 1. Dialog to add/remove lines from all 3 files
; 2. Capability to turn on/off forwarding globally,
;     or for each nick
; 3. Capability to forward to channels on different networks (this will happen when
;     vMon is converted to a VrS2 addon, because VrS2 supports multi-server, whereas
;     mIRC by itself does not...)
; 4. Logging of forwarded lines to a txt file
; 5. Anything else it might need? :)

; Let me know if there are any bugs. Send email to me at variant@variantrealities.com, or
; try to find me in #VrS on irc.frozenways.com.



on *:start: { vMon.Load }

on *:text:*:*: {
  if ($IsInNicks($nick) == $true) {
    if ($IsMonitorText($1-) == $true) {
      var %Counter = 1, %Total = $hget(vMon.SendTo,0).data
      while (%Counter <= %Total) {
        msg $hget(vMon.SendTo,%Counter) $gettok($1-,1- [ $+ [ $calc($numtok($1-,32) - 2) ] ] ,32)
        inc %Counter
      }
    }
  }
}


; For you unix types.. you can use this command instead of /vMon.Load
alias vMon.Rehash { vMon.Load }

; This alias simply loads the files into vMon's hash table
; No parameters are needed.
alias vMon.Load {
  var %FileList = Nicks.txt,SendTo.txt,Monitor.txt, %FCounter = 1, %FTotal = $numtok(%FileList,44)
  while (%FCounter <= %FTotal) {
    if ($hget( vMon. [ $+ [ $gettok($gettok(%FileList,%FCounter,44),1,46) ] ] )) { .hfree vMon. [ $+ [ $gettok($gettok(%FileList,%FCounter,44),1,46) ] ] } 
    hmake vMon. [ $+ [ $gettok($gettok(%FileList,%FCounter,44),1,46) ] ] 10
    var %Counter = 1, %Total = $lines($vMonDir($gettok(%FileList,%FCounter,44)))
    while (%Counter <= %Total) { 
      var %Line = $read -nl [ $+ [ %Counter ] ] $vMonDir($gettok(%FileList,%FCounter,44))
      hadd vMon. [ $+ [ $gettok($gettok(%FileList,%FCounter,44),1,46) ] ] %Counter %Line
      inc %Counter
    }
    inc %FCounter
  }
}


; Syntax: $IsInNicks(<nickname>)
alias -l IsInNicks {
  if ($hfind(vMon.Nicks,$1,1).data != $null) { return $true }
  else { return $false }
}

; Syntax: $IsMonitorText(<Text>)
; This alias will look through the text to see if any of the words listed
; in monitor.txt are contained in the supplied <Text>
alias -l IsMonitorText {
  var %Counter = 1, %Total = $hget(vMon.Monitor,0).data
  while (%Counter <= %Total) {
    if ($hget(vMon.Monitor,%Counter) isin $1-) { return $true }
    inc %Counter
  }
  return $false
}

; -------- Misc stuff -------
alias -l vMonDir { return " $+ $scriptdir $+ $iif($left($1,1) == \,$right($1-,-1),$1-) $+ " }
